import { Component, OnInit, Inject, ElementRef, ViewChild, AfterViewInit } from '@angular/core';
import { WINDOW } from './window.component';

@Component({
  selector: 'app-char3-d',
  templateUrl: './char3-d.component.html',
  styleUrls: ['./char3-d.component.css']
})
export class Char3DComponent implements OnInit, AfterViewInit {
  textToSay: string = '';
  iframeContent: string = '';
  message: string = '';

  @ViewChild('frameContentRef') frameContentRef!: ElementRef<HTMLIFrameElement>;
  @ViewChild('myButton') myButtonRef!: ElementRef<HTMLButtonElement>;

  embed: any[] = [16851,360,480,"''",1,1, 2695840, 0,1,1,"'5c6fde06460aa8ab405bf4f13cf93cf0'",0];
  spn: string = 'xyz';

  constructor(@Inject(WINDOW) private window: Window) {}

  ngOnInit(): void {
    const my_window = this.window as any;
    const that = this;
  }

  ngAfterViewInit() {
    this.window['vh_aiResponse'] = (aiString: string) => {
      if (!this.textToSay.trim()) {
        console.error('Input is empty');
        return;
      }

      const aiResponse = aiString;
      this.iframeContent = `<br><font color="#FF0000">Q - ${this.textToSay}</font><br><font color="#0000FF">A - ${aiResponse}</font>${this.iframeContent}`;

      // Update iframe content
      if (this.frameContentRef.nativeElement) {
        const contentDocument = this.frameContentRef.nativeElement.contentDocument;
        if (contentDocument) {
          contentDocument.open();
          contentDocument.write(
            `<html><body bgcolor="#FFFFFF">${this.iframeContent}</body></html>`
          );
          contentDocument.close();
        }
      }

      // Clear the input field
      this.textToSay = '';

      // Restore button opacity and pointer events
      if (this.myButtonRef.nativeElement) {
        this.myButtonRef.nativeElement.style.opacity = '1';
        this.myButtonRef.nativeElement.style.pointerEvents = 'unset';
      }
    };
  }

  aiFunction() {
    if (this.textToSay.trim() !== '') {
      if (this.myButtonRef.nativeElement) {
        this.myButtonRef.nativeElement.style.opacity = '0.5';
        this.myButtonRef.nativeElement.style.pointerEvents = 'none';
      }
    }
  }

  sayAudio(event: Event) {
    event.preventDefault();
    const trimmedText = this.textToSay.trim();
    this.window['sayAI'](trimmedText, 1, 1, 3);
    this.aiFunction();
  }

  updateMessage(eventType: string) {
    this.message += eventType;
  }
}
